// (c) Copyright Open Text Corporation

package com.opentext.livelink.service.hello;

import java.io.*;
import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.opentext.api.*;
import com.opentext.livelink.service.core.*;

/**
 * HelloWorld defines the service that represents a prototypical Hello World! service.
 *
 * @version 2013-08-27
 */
public class HelloWorld
	extends Service
	implements IHelloWorld, Serializable
{
	private static final long serialVersionUID = 20130827L;
	private static Log sLog = LogFactory.getLog( "com.opentext.livelink.service.hello.HelloWorld" );

	public HelloWorld()
	{
	}

	public HelloMessage getMessage()
	{
		HelloMessage		retval = null;
		LLSession			lapiSession;
		LAPI_SERVICE		service;

		LLValue				args = new LLValue();
		LLValue				result = new LLValue();
		LLValue				env = getLapiEnvironment();

		args.setAssoc();

		if ( sLog.isTraceEnabled() )
		{
			sLog.trace( "begin: HelloWorld.getMessage()" );
		}

		try
		{

			lapiSession = getLapiSession();
			service = new LAPI_SERVICE( lapiSession );

			int status = service.InvokeService( SERVICE_NAME, "GetMessage", args, env, result );

			if ( status != 0 )
			{
				ExceptionUtil.throwLivelinkException( lapiSession.getStatus(), lapiSession.getStatusMessage(), lapiSession.getErrMsg(), lapiSession.getApiError(), "urn:Hello.service.livelink.opentext.com" );
			}
			else if ( result.isDefined() )
			{
				retval = (HelloMessage) SDOUtil.getSDOValue( "com.opentext.livelink.service.hello", result );
			}
		}
		catch ( RuntimeException ex )
		{
			ExceptionUtil.handleException( ex );
		}

		if ( sLog.isTraceEnabled() )
		{
			sLog.trace( "end:   HelloWorld.getMessage()" );
		}

		return retval;
	}

}
